--[[
Descripttion:模块管理
version:
Author: Neo,Huang
Date: 2022-07-04 11:24:54
LastEditors: Neo,Huang
LastEditTime: 2022-07-04 13:36:28
--]]
local lfsUtil = require "utils.lfsUtil"

local root = {}

-- 获取模块列表
function root.get_module_class_map()
	local mapModule = {}
	local files = lfsUtil:get_path_lua_files("dev/modules")
	for _, file in ipairs(files) do
		mapModule[file] = require("modules." .. file)
	end

	return mapModule
end
-- 获取所有活动模版类
function root.get_activity_class_list()
	local mapClass = {}
	local files = lfsUtil:get_path_lua_files("dev/activity")
	for _, file in ipairs(files) do
		local arr = string.split(file, "act")
		if arr and #arr > 0 then
			local templateId = tonumber(arr[1])
			mapClass[templateId] = require("activity." .. file)
		end
	end

	return mapClass
end

function root.getAllmodes()
	local modes = {}

	return modes
end

return root
