--[[
Descripttion:
version:
Author: Neo,Huang
Date: 2022-07-04 11:24:54
LastEditors: Neo,Huang
LastEditTime: 2022-07-04 13:41:35
--]]
local skynet = require("skynet")

local DB_SERVER = ".db_server"

local root = {}

function root.getDataFromDB(tabName, keyName, keyValue, needSavetoDB)
	return skynet.call(DB_SERVER, "lua", "get", tabName, keyName, keyValue, needSavetoDB)
end

function root.addDataToDB(data)
	return skynet.call(DB_SERVER, "lua", "add", data)
end

function root.updateDataToDB(data)
	return skynet.call(DB_SERVER, "lua", "update", data)
end

function root.addOrUpdateDataToDB(data)
	return skynet.call(DB_SERVER, "lua", "addOrUpdate", data)
end

function root.delDataToDB(data)
	return skynet.call(DB_SERVER, "lua", "del", data)
end

function root.getDataFromRedis(tabName, keyValue)
	return skynet.call(DB_SERVER, "lua", "getFromRedis", tabName, keyValue)
end

function root.setDataToRedis(data)
	return skynet.call(DB_SERVER, "lua", "setToRedis", data)
end

function root.delDataToRedis(tabName, keyValue)
	return skynet.call(DB_SERVER, "lua", "delToRedis", tabName, keyValue)
end

function root.addOrUpdateDataToMysql(data)
	return skynet.call(DB_SERVER, "lua", "addOrUpdateToMysql", data)
end

function root.callDataSer(cmd, ...)
	return skynet.call(DB_SERVER, "lua", cmd, ...)
end

function root.callMysqlSer(cmd, ...)
	return skynet.call(".mysql", "lua", cmd, ...)
end

function root.sendMysqlSer(cmd, ...)
	return skynet.send(".mysql", "lua", cmd, ...)
end

function root.callRedisSer(cmd, ...)
	return skynet.call(".redis", "lua", cmd, ...)
end

function root.sendRedisSer(cmd, ...)
	return skynet.send(".redis", "lua", cmd, ...)
end

return root
