--[[
Descripttion:玩家信息
version:
Author: Neo,Huang
Date: 2021-09-15 19:47:54
LastEditors: Neo,Huang
LastEditTime: 2021-09-15 19:47:55
--]]
local moduleData = require("data.module")

local MODULE_NAME = "user"

local root = {}

-- 设置注册数据
function root:user_init_register_info(uid, info)
    if uid == nil or is_empty(info) then
        return false
    end
    moduleData:hset(uid, MODULE_NAME, "uid", uid)
    moduleData:hset(uid, MODULE_NAME, "registerTime", skynet_time())
    moduleData:hset(uid, MODULE_NAME, "version", info.version or "")
    moduleData:hset(uid, MODULE_NAME, "registerVersion", info.version or "")
    moduleData:hset(uid, MODULE_NAME, "appVerison", info.version or "")
    moduleData:hset(uid, MODULE_NAME, "uuid", info.uuid or "")
    moduleData:hset(uid, MODULE_NAME, "udid", info.udid or "")
    moduleData:hset(uid, MODULE_NAME, "device", info.device or "")
    moduleData:hset(uid, MODULE_NAME, "sysVer", info.sysVer or "")
    moduleData:hset(uid, MODULE_NAME, "deviceId", info.deviceId or "")
    moduleData:hset(uid, MODULE_NAME, "channel", info.channel)

    moduleData:hset(uid, MODULE_NAME, "phone", info.phone)
    moduleData:hset(uid, MODULE_NAME, "shareCode", info.shareCode)

    moduleData:hset(uid, MODULE_NAME, "nickname", info.nickname or string.format("玩家%06d", uid))
    -- 非测试环境随机密码
    local password = info.password
    if is_nil(password) then
        if not IS_TEST then
            local r = {}
            for i = 1, 8 do
                table.insert(r, string.char(math.random(97, 122)))
            end
            password = table.concat(r)
        else
            password = "123456"
        end
    end
    moduleData:hset(uid, MODULE_NAME, "password", password)
    return true
end
-- 密码匹配
function root:user_is_match_password(uid, password)
    if uid == nil then
        return false
    end
    return password == moduleData:hget(uid, MODULE_NAME, "password")
end
-- 渠道匹配
function root:user_is_match_channel(uid, channel)
    if uid == nil or channel == nil then
        return false
    end
    return channel == moduleData:get_channel(uid)
end

-- 账号状态
function root:get_status(uid)
    if uid == nil then
        return 1
    end
    return moduleData:hget(uid, MODULE_NAME, "status")
end

-- 获取当前邀请码
function root:get_share_code(uid)
    if is_empty(uid) then
        return
    end
    return moduleData:hget(uid, MODULE_NAME, "shareCode")
end

-- 绑定邀请码
function root:band_share_code(uid, sharecode)
    if is_empty(uid) then
        return false
    end
    moduleData:hset(uid, MODULE_NAME, "bandShareCode", sharecode)
    return true
end

-- 获取属性
function root:get_key_int(uid, key)
    if uid == nil or is_empty(key) then
        return 0
    end
    return moduleData:hget_int(uid, MODULE_NAME, key)
end
function root:get_key_info(uid, key)
    if uid == nil or is_empty(key) then
        return 0
    end
    return moduleData:hget(uid, MODULE_NAME, key)
end
function root:get_key_json(uid, key)
    if uid == nil or is_empty(key) then
        return 0
    end
    return moduleData:hget_json(uid, MODULE_NAME, key)
end

return root
