--[[
Descripttion:支付订单模块
version:
Author: Neo,Huang
Date: 2022-08-17 16:04:20
LastEditors: Neo,Huang
LastEditTime: 2022-09-05 10:05:30
--]]
local root = class("order", require("base.baseModule"))

function root:ctor(id)
    root.super.ctor(self, id, "order", "id", true, false)
    self.id = id
end

function root:mysql_get_init_columns()
    return {
        id = "bigint(11) NOT NULL AUTO_INCREMENT COMMENT 'ID'",
        payName = "varchar(64) DEFAULT '' COMMENT '支付名称'",
        code = "varchar(128) DEFAULT '' COMMENT 'SDK支付方回调错误码'",
        uid = "int(11) NOT NULL COMMENT '用户id'",
        orderNo = "varchar(64) DEFAULT '' COMMENT '订单号'",
        diamond = "int(11) DEFAULT '0' COMMENT '钻石'",
        gold = "bigint(20) DEFAULT '0' COMMENT '金币'",
        gid = "int(10) DEFAULT NULL COMMENT '商品ID'",
        amount = "decimal(5,2) DEFAULT NULL COMMENT '订单金额,单位分'", -- 入库单位元
        time = "varchar(32) DEFAULT NULL COMMENT '订单时间'",
        createtime = "varchar(50) DEFAULT NULL COMMENT '支付服处理时间'",
        status = "tinyint(1) DEFAULT NULL COMMENT '订单状态:0手动发放订单,1游戏逻辑自动发放订单'",
        resMsg = "varchar(255) DEFAULT NULL COMMENT '注释'",
        channel = "int(11) DEFAULT 0 COMMENT '渠道'",
        type = "int(11) DEFAULT 0 COMMENT '支付类型'",
        readStatus = "int(11) DEFAULT 0 COMMENT '状态:1客户端是否已经被轮询获取'",
        cut = "tinyint(1) DEFAULT 0 COMMENT '状态: 1 订单扣除'",
        gameStatus = "tinyint(1) DEFAULT 0 COMMENT '游戏服处理:0未处理,1处理'"
    }
end

return root
