--[[
Descripttion:玩家事件
version:
Author: Neo,Huang
Date: 2022-07-05 19:59:16
LastEditors: Neo,Huang
LastEditTime: 2022-07-05 20:08:31
--]]
local dataMode = require("dataMode")

local root = {}

-- 初始化
function root:init()
    -- 模块
    self.moduleList = {}
    for k, v in pairs(dataMode:get_module_class_map()) do
        -- 模块是否监听事件
        if v["user_event"] then
            table.insert(self.moduleList, v.new())
        end
    end
end

-- 触发事件
function root:user_event(uid, evtId, evtParams)
    if self.moduleList == nil then
        self:init()
    end
    for k, v in ipairs(self.moduleList) do
        v:user_event(uid, evtId, evtParams)
    end
end

return root
