--[[
Descripttion:
version:
Author: Neo,Huang
Date: 2022-08-17 16:04:20
LastEditors: Neo,Huang
LastEditTime: 2022-08-24 14:30:45
--]]
local redisUtil = require("utils.redisUtil")
local lib_game_redis = require("lib_game_redis")

local root = {}

----------------------------------------
-- 节点负载
----------------------------------------
-- 清除节点负载
function root:node_load_init_grains(nodeName)
    if is_empty(nodeName) then
        return false
    end
    log.info("node_load_init_grains nodeName[%s]", tostring(nodeName))

    local key = string.format("load:node:%s", nodeName)
    lib_game_redis:del(key)
    return true
end
-- 更新负载
function root:node_load_update_grains(nodeName, delta)
    if is_empty(nodeName) or is_empty(delta) then
        return false
    end
    local key = string.format("load:node:%s", nodeName)
    local grains = lib_game_redis:incrby(key, delta)
    log.info(
        "node_load_update_grains nodeName[%s] delta[%s] grains[%s]",
        tostring(nodeName),
        tostring(delta),
        tostring(grains)
    )
    return true
end
-- 获取节点负载
function root:node_load_get_grains(nodeName)
    local key = string.format("load:node:%s", nodeName)
    return redisUtil.get_int(key)
end

return root
