--[[
Descripttion:角色管理
version:
Author: Neo,Huang
Date: 2021-08-31 20:45:03
LastEditors: Neo,Huang
LastEditTime: 2021-09-24 09:55:30
--]]
local role = require "role"

local root = class("roleMgr")

function root:ctor()
    self.roleList = {}
    self.amount = 0
end

function root:login_role(uid, gSession)
    local roleObj = role.new(uid, gSession)
    roleObj:login(gSession)
    log.print("login_role %s", uid)
    self.roleList[uid] = roleObj
    self.amount = self.amount + 1
end

function root:logout_role(uid)
    local roleObj = self:get_role_obj(uid)
    if not roleObj then
        return
    end

    log.print("logout_role %s", uid)
    roleObj:logout_modules()
    self.roleList[uid] = nil
    self.amount = self.amount - 1
end

function root:get_role_obj(uid)
    return self.roleList[uid]
end

function root:get_role_obj_list()
    return self.roleList
end

-- 派发游戏事件
function root:dispath_game_event(uid, eventId, eventParams)
    local roleObj = self:get_role_obj(uid)
    if not roleObj then
        return
    end

    roleObj:dispath_game_event(eventId, eventParams)
end

return root
