--[[
Descripttion:全局业务服
version:
Author: Neo,Huang
Date: 2023-11-16 21:45:09
LastEditors: Neo,Huang
LastEditTime: 2023-11-18 13:58:16
--]]
local skynet = require "skynet"
require "skynet.manager"
local init_nodes = require("init_nodes")

skynet.start(
    function()
        -- 初始化控制台
        init_nodes:init_console()

        -- 日志
        init_nodes:init_logger()
        -- 数据库
        init_nodes:init_mysql()
        -- redis
        init_nodes:init_redis()
        -- 配置
        init_nodes:init_config()

        -- skynet.uniqueservice("backupSrv")
        skynet.uniqueservice("mailSrv")
        skynet.uniqueservice("dreamSrv")
        skynet.uniqueservice("battlerecordSrv")
        skynet.uniqueservice("rollSrv")

        -- 集群
        init_nodes:init_cluster()

        skynet.exit()
    end
)
