--[[
Descripttion:追梦
version:
Author: Neo,Huang
Date: 2023-11-16 21:45:09
LastEditors: Neo,Huang
LastEditTime: 2023-11-16 23:20:12
--]]
local timer = require("timer")
local baseService = require("baseService")
local lib_game_mysql = require("lib_game_mysql")
local util_box = require("utils.util_box")

local timerDelExpireMail = nil

local CMD = {}

-- 清理过期追梦记录
local function l_del_expire_record()
	local currTime = skynet_time()
	local sql = string.format("delete from mdl_dream where expireTime >0 and expireTime < %s;", tostring(currTime))
	local ret = lib_game_mysql:query(sql)
	log.info("l_del_expire_record sql[%s] ret[%s]", tostring(sql), tostring(ret))
	-- 统计 - 保留30
	local ti = currTime - 86400 * 30
	util_box:dream_del_day_statement(ti)
end

function CMD.onStart()
	timerDelExpireMail = timer.timeOut(60, l_del_expire_record)
end

function CMD.onStop()
	-- 取消定时器
	timerDelExpireMail.func = nil
end

baseService.start(CMD, ".dreamCenter", true)
