--[[
Descripttion:节点配置
version:
Author: Neo,Huang
Date: 2022-07-05 13:40:50
LastEditors: Neo,Huang
LastEditTime: 2022-07-05 13:41:07
--]]
local root = {}

-- master
root["master"] = {
    debugPort = 8100,
    port = 8101,
    agentCount = 1,
    bodyLimit = 8192
}
root["global"] = {
    debugPort = 8102
}
root["resource"] = {
    debugPort = 8103
}
root["match"] = {
    debugPort = 8104
}

-- 登陆服
root["login_1_1"] = {
    ip = "0.0.0.0",
    debugPort = 8105,
    port = 8106,
    agentCount = 5,
    bodyLimit = 8192
}

-- 网关
root["gate_1_1"] = {
    ip = "8.134.163.21",
    debugPort = 8107,
    port = 8108,
    maxClient = 5000,
    nodelay = 1,
    protocol = "ws",
    weight = 50, -- 权重
    wsPort = 8109 -- websocket端口
}

-- 游戏服
root["game_1_1"] = {
    debugPort = 8110,
    weight = 50 -- 权重
}

root["web"] = {
    ip = "0.0.0.0",
    debugPort = 8111,
    port = 8112,
    agentCount = 5,
    bodyLimit = 8192
}

return root
