--[[
Descripttion:节点配置
version:
Author: Neo,Huang
Date: 2022-07-05 13:40:50
LastEditors: Neo,Huang
LastEditTime: 2022-07-05 13:41:07
--]]
local root = {}

-- master
root["master"] = {
    debugPort = 8200,
    port = 8300,
    agentCount = 1,
    bodyLimit = 8192
}
root["global"] = {
    debugPort = 8201
}
root["resource"] = {
    debugPort = 8202
}
root["match"] = {
    debugPort = 8203
}

-- 登陆服
root["login_1_1"] = {
    ip = "0.0.0.0",
    debugPort = 8204,
    port = 8301,
    agentCount = 5,
    bodyLimit = 8192
}

-- 网关
root["gate_1_1"] = {
    ip = "192.168.10.14",
    debugPort = 8205,
    port = 8302,
    maxClient = 5000,
    nodelay = 1,
    protocol = "ws",
    weight = 50, -- 权重
    wsPort = 8303 -- websocket端口
}

-- 游戏服
root["game_1_1"] = {
    debugPort = 8206,
    weight = 50 -- 权重
}

root["web"] = {
    ip = "0.0.0.0",
    debugPort = 8207,
    port = 8303,
    agentCount = 5,
    bodyLimit = 8192
}

return root
