#! /bin/bash
# 打包日志文件

# 绝对路径
abspath=$(cd "$(dirname "$0")";pwd)
source $abspath/func.sh
set_global

platform=`get_platform`
# 日志时间 不传参数则打包昨天数据
if [ $# -ne 1 ];then
    if [ "$platform" == "macosx" ] ;then
        log_date=`date -v-1d +"%Y-%m-%d"`
    else
        log_date=`date  +"%Y-%m-%d" -d  "-1 days"`
    fi
    echo "$log_date"
else
    log_date=$1
fi


# 日志目录
log_dir=`get_config statistic_path`
zip_dir=`get_config zip_statistic_path`

# 创建日志目录
if [ ! -d "$zip_dir/$log_date" ];then
    mkdir -p $zip_dir/$log_date
fi

cd $log_dir
# 日志文件集合
logArray=("client" "event" "login" "logout" "open" "pay" "register" "settle" "resource" "user")
for file in ${logArray[@]}
do
    log_file="$file-$log_date.log"
    if [ -f "$log_file" ];then
        zip ${zip_dir}/$log_date/$file.log.zip $log_file
    fi
done